/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2012  Mohammadhossein Malmir <email>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "escape_object.h"
#include <rcsc/math_util.h>

using namespace rcsc;
using namespace std;


Escape_Object::Escape_Object() :
    M_agent( static_cast< PlayerAgent * >(0) ),
    M_position( Vector2D() ),
    M_score ( -1000.0 ) {}

///******************************************************************/
Escape_Object::Escape_Object( PlayerAgent* agent, Vector2D pos ):
    M_agent( agent ),
    M_position( pos )
    {
      compute(); 
    }
    
///******************************************************************/
void Escape_Object::compute()
{
  const WorldModel & wm = M_agent->world();
  
  const double dist_from_me_weight         = 1.0; 
        double dist_to_target_weight       = 1.0;
  const double dist_from_ball_weight       = 1.0;
  
  M_score = M_position.dist( wm.self().pos() ) * dist_from_me_weight
          + distToTarget() * dist_to_target_weight
          + distToBall() * dist_from_ball_weight;
}


///******************************************************************/

double Escape_Object::distToTarget()
{
  const WorldModel & wm = M_agent->world();
  
  int my_unum = wm.self().unum();
  
  Vector2D target = ServerParam::i().theirTeamGoalPos();
  
  return target.dist( M_position );
}

///******************************************************************/

double Escape_Object::distToBall()
{
  const WorldModel & wm = M_agent->world();
  
  return wm.ball().pos().dist( wm.self().pos() );
}

