/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2011  <copyright holder> <email>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "taskevaluator.h"
#include "sample_coach.h"
#include "strategy.h"
#include <rcsc/common/server_param.h>
#include <rcsc/common/audio_memory.h>

using namespace rcsc;

TaskSequence::TaskRoute TaskEvaluator::execute( PlayerAgent * agent )
{
  const WorldModel & wm = agent->world();
  
        double dist_to_goal_weight = 1.0;
        double dist_to_goal_line_weight = 1.0;
  const double dist_from_me_weight = 1.0;
        double pass_atrget_y_diff_weight = 1.0;

  double score = 0.0;
  
  double best_score = -1000.0;
  TaskSequence::TaskRoute best_task;
  best_task.target_ = Vector2D::INVALIDATED;
  best_task.type_ = TaskSequence::NONE;
  
  const std::vector<TaskSequence::TaskRoute>::const_iterator end_task = M_tasks.end();
  
  for( std::vector<TaskSequence::TaskRoute>::const_iterator first_task = M_tasks.begin() ; first_task != end_task ; first_task++ )
  {  
    score = (*first_task).target_.dist( ServerParam::i().theirTeamGoalPos() ) * dist_to_goal_weight +
	    std::fabs((*first_task).target_.x - ServerParam::i().theirTeamGoalLineX() ) * dist_to_goal_line_weight +
	    ( (*first_task).target_ ).dist( wm.self().pos() ) * dist_from_me_weight;
	    
     Vector2D mypos = wm.self().pos();
     int my_side = ( mypos.y >= 0.0 ) ? +1 : -1;
  
     Vector2D top_left = ( my_side == -1 ) ? mypos : Vector2D( mypos.x , -ServerParam::i().goalWidth() / 2 );
     Vector2D bottom_right = ( my_side == -1 ) ?
			  Vector2D( ServerParam::i().theirTeamGoalLineX() , ServerParam::i().goalWidth() / 2 ) : 
			  Vector2D( ServerParam::i().theirTeamGoalLineX() , mypos.y ) ;
    
    if( score > best_score )
    {
      best_score = score;
      best_task = *first_task;
    }	    
  }
  
  return best_task;
}

/***********************************************************************/

void TaskEvaluator::pushEnd(TaskSequence::TaskRoute end_task)
{
    M_tasks.push_back( end_task );
}
